library Zelda_GBC;

uses
  ShareMem,
  Needs,
  Classes,
  SysUtils;

{$E .kpl}

resourcestring
 SKPLDescription = 'The Legend of Zelda: Oracles';

Var
 ROM: PBytes = NIL;
 RomSize: Integer = 0;
 EndsRoot: PTableItem = NIL;
 MaxCodes: Integer = 0;
 Align: Integer = 1;

Function Description: String; stdcall;
begin
 Result := SKPLDescription
end;

Function NeedEnd: Boolean; stdcall;
begin
 Result := False
end;

Function GetMethod: TMethod; stdcall;
begin
 Result := tmNone
end;

Procedure SetVariables(X: PBytes; Sz: Integer; ER: PTableItem; MC, AL: Integer); stdcall;
begin
 ROM := X;
 RomSize := Sz;
 EndsRoot := ER;
 MaxCodes := MC;
 Align := AL
end;

{      }
procedure DeleteDir(Dir,GrName,ListName : string);
var
  filename:string;
begin
  filename:=dir+GrName+'_'+ListName+'_taddrout.txt';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_tstrout';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_tstroutmin';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_taddroutGD';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_tstroutGD';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_NF';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_NFaddr';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_strnew';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_strold';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_addr.txt';
  if FileExists(filename)then
  DeleteFile(filename);
  filename:=dir+GrName+'_'+ListName+'_Origaddr.txt';
  if FileExists(filename)then
  DeleteFile(filename);
  RemoveDir(dir);
end;


function GetData(Strings:Pointer; Table:Pointer; Flags,address:integer; GrName,ListName:string; var plFixed:boolean; var SlStr:string): AnsiString; stdcall;
var
 R: PTextString;
 TextStrings:PtextStrings;
 s,st:string;
 i,j,kk,l:integer;
 lnw:word;
 tstrin:TFileStream;
 taddrout:TTextFileStream;
 tstrout:TFileStream;
 tstrinmin:TFileStream;
 addrin:TStringList;
 strin: TStringList;
 strinmin: TStringList;
 filename:string;
 filename1:string;
 filename2:string;
 filename3:string;
 filename4:string;
 str,addrout,strout:string;
 fa, fs, ff:boolean;
begin
    fa:=false;
    fs:=false;
    ff:=false;
  addrin := TStringList.Create;
  addrout := '';
  strin := TStringList.Create;
  strinmin:= TStringList.Create;
  strout:= '';
  str:='';
  filename1:='tmp\'+GrName+'_'+ListName+'_tstrout';
  tstrin:=TFileStream.Create(filename1,fmOpenReadWrite+fmShareDenyNone);
  filename2:='tmp\'+GrName+'_'+ListName+'_tstroutmin';
  tstrinmin:=TFileStream.Create(filename2,fmOpenReadWrite+fmShareDenyNone);
  filename3:='tmp\'+GrName+'_'+ListName+'_tstroutGD';
  if not FileExists(filename3) then
  tstrout:=TFileStream.Create(filename3,fmCreate)
  else tstrout:=TFileStream.Create(filename3,fmOpenReadWrite+fmShareDenyNone);
  filename4:='tmp\'+GrName+'_'+ListName+'_taddroutGD';
  if not FileExists(filename4) then
  taddrout:=TTextFileStream.Create(filename4,fmCreate)
  else taddrout:=TTextFileStream.Create(filename4,fmOpenReadWrite+fmShareDenyNone);
  tstrin.position:=0;
  while tstrin.position <>tstrin.Size do begin
        tstrin.read(lnw,2);
        SetLength(s, lnw);
        tstrin.Read(s[1],lnw*sizeof(char));
        strin.Append(s);
        end;
  tstrinmin.position:=0;
  while tstrinmin.position <>tstrinmin.Size do begin
        tstrinmin.read(lnw,2);
        SetLength(s, lnw);
        tstrinmin.Read(s[1],lnw*sizeof(char));
        strinmin.Append(s);
        end;
  filename:='tmp\'+GrName+'_'+ListName+'_taddrout.txt';
  addrin.LoadFromFile(filename);
 Result := '';
 TextStrings:=StringsToTextStrings(Table,Strings,Flags);    //     
 If TextStrings = NIL then Exit;
 With TextStrings^ do
 begin
  R := Root;
  While R <> NIL do
  begin
   Result := Result + R^.Str;
   R := R^.Next
  end
 end;
 for i:=0 to addrin.count-1 do
     if address=strtoint(addrin[i]) then begin
        addrout:=inttostr(address);
        fa:=true;
        break; end;
 kk:=0;
 if fa then
    for i:=0 to strinmin.count-1 do
      begin
        if fs then break;
        if length(strinmin[i])=length(result) then
         begin
           kk:=0;
           for j:=1 to length(result) do
            begin
               if result[j]=strinmin[i][j] then inc(kk)
               else begin kk:=0; break; end;
               if kk=length(result) then
                  begin fs:=true; break; end
            end;
         end;
        end;
 kk:=0;
 if fs then
    for i:=0 to strin.count-1 do begin
       if ff then break;
       for j:=1 to length(strin[i]) do
       begin
           if strin[i][j]=result[1] then
            begin
              st:=Copy(strin[i],j,length(strin[i]));
              //if length((strin[i]))-length(st)<>length((strin[i]))-length(result)
              // then continue else
              // if ((result[length(result)]=#0) or (result[length(result)-1]=#07)) and ((st[length(st)]=#0) or (st[length(st)-1]=#07)) then
              if length(st)= length(result) then
                for l:=1 to length(st) do
                   if  st[l]=result[l] then inc(kk)
                   else begin kk:=0; break; end;
            end;
           if kk=length(result) then begin
             addrout:=(inttostr(address));
             strout:=result;
             str:=strin[i];
             kk:=0; ff:=true; break; end;
          end;
    end;
if ff then begin
tstrout.Position := tstrout.Size;
lnw:=length(strout);
tstrout.Write(lnw,2);
tstrout.Write(strout[1],lnw*sizeof(char));
taddrout.Position := taddrout.Size;
taddrout.WriteLn(addrout);
plFixed:=true;
SlStr:=str;
end;
    addrin.Free;
    strin.Free;
    strinmin.Free;
    tstrout.Free;
    taddrout.Free;
    tstrin.Free;
    tstrinmin.Free;
end;

procedure PlagPtrFix(PRoot:pointer; strout,plStr:string; GrName,ListName:string; PPointerTableData:TPointerTable;  var ROM:PBytes; var PP:PPointer; var Ptrs:PDwords; var BCounts:PDwords; Jk:integer; Var SkipWriteStrToROM:boolean); stdcall;
 Function FindTextString(Node: PTextString; S: String): Integer;
    begin
    Result := 0;
    While Node <> NIL do With Node^ do
      begin
        If S = Str then Exit;
        Inc(Result);
        Node := Next;
      end;
    Result := -1;
  end;
label first;
var
  Root: PtextString absolute PRoot;
  i:integer;
  k:integer;
  j:integer;
  NfStr:string;
  filename:string;
  filename1:string;
  filename2:string;
  St,s:string;
  Len:Dword;
  lnw:word;
  NF:TFileStream;
  NFaddr:TTextFileStream;
  NfList:TStringList;
  NfAddrList:TStringList;
Begin
SkipWriteStrToROM:=true;
with PPointerTableData do
begin
      NfList:= TStringList.Create;
      NfAddrList:= TStringList.Create;
      filename1:='tmp\'+GrName+'_'+ListName+'_NF';
      if not FileExists(filename1) then
      NF:=TFileStream.Create(filename1,fmCreate)
      else NF:=TFileStream.Create(filename1,fmOpenReadWrite+fmShareDenyNone);
      filename2:='tmp\'+GrName+'_'+ListName+'_NFaddr';
      if not FileExists(filename2) then
      NFaddr:=TTextFileStream.Create(filename2,fmCreate)
      else NFaddr:=TTextFileStream.Create(filename2,fmOpenReadWrite+fmShareDenyNone);
      NF.Position:=0;
      if NF.Size<>0 then
      while NF.position <>NF.Size do begin
        NF.read(lnw,2);
        SetLength(s, lnw);
        NF.Read(s[1],lnw*sizeof(char));
        NfList.Append(s);
        end
      else Goto First;
      NFaddr.Position:=0;
      if NFaddr.Size<>0 then
      while not NFaddr.Eof do begin
        st:=NFaddr.ReadLn;
        NfAddrList.append(st);
        end;
      NF.free;
      NFaddr.free;
     // for i:=0 to NfList.count-1 do
     i:=0;
     while i<NfList.count do
       begin
        st:=NfList[i];
        K:=FindTextString(Root, St);
        If (K >= 0) and (Integer(Ptrs^[K])>= 0) then
        begin
         NfList.Delete(i);
         J:=strtoint(NfAddrList[i]);
         NfAddrList.Delete(i);
         len:=length(st)-length(StrOut);
         Ptrs^[J]:= Ptrs^[K]+len;
         BCounts^[J]:= BCounts^[K]-len;
         Ptrs^[J]:= Ptrs^[K];
         BCounts^[J]:= BCounts^[K];
         With PP^ do
         begin
          pnPtr:= Integer(Ptrs^[J]);
          If ptPunType then
           SetPointerPun(ROM, ptInterval, pnPos, pnPtr, pnReference) Else
           SetPointer(ROM, pnPos, pnPos, pnPtr, pnReference);
         end;
         dec(i);
        end;
        inc(i);
       end;
      NF:=TFileStream.Create(filename1,fmCreate);
      NFaddr:=TTextFileStream.Create(filename2,fmCreate);
      NF.Position:=0;
      for i:=NfList.count-1 downto 0 do
        begin
        lnw:=length(NfList[i]);
        NF.Write(lnw,2);
        st:=NfList[i];
        NF.Write(st[1], lnw*sizeof(char));
        end;
      NFaddr.Position:=0;
      for i:=0 to NfAddrList.count-1 do
        NFaddr.WriteLn(NfAddrList[i]);
      First:
      j:=Jk;
      st:=plStr;
      K:=FindTextString(Root, St);
        If (K>=0) and (Integer(Ptrs^[K])>= 0) then
        begin
         len:=length(st)-length(StrOut);
         Ptrs^[J]:= Ptrs^[K]+len;
         BCounts^[J]:= BCounts^[K]-len;
         With PP^ do
         begin
          pnPtr:= Integer(Ptrs^[J]);
          If ptPunType then
           SetPointerPun(ROM, ptInterval, pnPos, pnPtr, pnReference) Else
           SetPointer(ROM, pnPos, pnPos, pnPtr, pnReference);
         end;
       end
       else
        begin
          NF.Position := NF.Size;
          lnw:=length(plStr);
          NF.Write(lnw,2);
          st:=plStr;
          NF.Write(st[1], lnw*sizeof(char));
          NFaddr.Position := NFaddr.Size;
          NFaddr.WriteLn(inttostr(Jk));
        end;

end;
    NFaddr.Free;
    NF.Free;
    NfList.Free;
    NfAddrList.Free;
End;


Function GetOptimization(Strings:Pointer; Table:Pointer; Addr,OrigAddr,Flags:Integer; GrName,ListName:string; FirstStart:boolean):boolean; stdcall;
 //begin end;
 procedure WriteSTRsteam(const Str,name : string);
  var
    FileStream : TFileStream;
    x:word;
  begin
      if not FileExists(name) then
         FileStream := TFileStream.Create(name,fmCreate)
      else
         FileStream := TFileStream.Create(name,fmOpenReadWrite+fmShareDenyNone);
         x:=0;
         FileStream.Position := FileStream.Size;
         x:=Length(Str);
         FileStream.Write(x, 2);
         FileStream.Write(Str[1],x*sizeof(char));
         FileStream.Free;
    end;

 procedure WriteSTR(const Str,name : string);
  var
    FileStream : TFileStream;
    x:word;
  begin
      if not FileExists(name) then
         FileStream := TFileStream.Create(name,fmCreate)
      else
         FileStream := TFileStream.Create(name,fmOpenReadWrite+fmShareDenyNone);
         FileStream.Position := FileStream.Size;
         x:=Length(Str);
         FileStream.Write(Str[1],x*sizeof(char));
         FileStream.Free;
    end;

  procedure WritelnSTR(var Str : string);
  begin
    Str:=Str+#13#10;
  end;
var
 st,res:string;
 R: PTextString;
 plSTR: PStrings absolute Strings;
 i:integer;
 TextStrings:PtextStrings;
 Addrstr,filename:AnsiString;
begin
 if FirstStart then DeleteDir('tmp/',GrName,ListName);
 result:=true;
 Res := '';
 TextStrings:=StringsToTextStrings(Table,Strings,Flags);    //     
 If TextStrings = NIL then Exit;
 With TextStrings^ do
 begin
  R := Root;
  While R <> NIL do
  begin
   Res := Res + R^.Str;
   R := R^.Next
  end;
 end;
 CreateDir('tmp\');
 filename:='tmp\'+GrName+'_'+ListName+'_strnew';
 //WritelnSTR(res);
 WriteSTRsteam(res,filename);
 filename:='tmp\'+GrName+'_'+ListName+'_Origaddr.txt';
 Addrstr:=inttostr(OrigAddr);
 WritelnSTR(Addrstr);
 WriteSTR(Addrstr,filename);
 filename:='tmp\'+GrName+'_'+ListName+'_addr.txt';
 Addrstr:=inttostr(Addr);
 WritelnSTR(Addrstr);
 WriteSTR(Addrstr,filename);
 filename:='tmp\'+GrName+'_'+ListName+'_strold';
 st:=plSTR^.Root.stOriginal;
 //WritelnSTR(st);
 WriteSTRsteam(st,filename);
end;

procedure Optimization(GrName,ListName:string); stdcall;
 //begin end;
 var
  fList2: TStringList;
  fList3: TStringList;
  addr: TStringList;
  Origaddr: TStringList;
  strnew: TStringList;
  strold: TStringList;
  addrout: TStringList;
  i,j,k,l,k2,kk: integer;
  lnw:word;
  stri,strj,strt,st:string;
  tstrnew:TFileStream;
  tstrold:TFileStream;
  tstrout:TFileStream;
  //taddrout:TTextFileStream;
  tstroutmin:TFileStream;
  s:ansistring;
  filename:string;
  filename0:string;
  filename1:string;
  filename2:string;
  filename3:string;
  filename4:string;
  filename5:string;
  ln:integer;
begin
  s:='';
  l:=0;
  kk:=0;
  fList2:= TStringList.Create;
  fList3:= TStringList.Create;
  addrout := TStringList.Create;
  addr := TStringList.Create;
  Origaddr := TStringList.Create;
  strnew:= TStringList.Create;
  strold:= TStringList.Create;
  fList2.Sorted:=true;
  fList2.Duplicates:=dupIgnore;
  fList3.Sorted:=true;
  fList3.Duplicates:=dupIgnore;
  addrout.Sorted:=true;
  addrout.Duplicates:=dupIgnore;
  filename1:='tmp\'+GrName+'_'+ListName+'_strnew';
  tstrnew:=TFileStream.Create(filename1,fmOpenReadWrite+fmShareDenyNone);
  filename2:='tmp\'+GrName+'_'+ListName+'_strold';
  tstrold:=TFileStream.Create(filename2,fmOpenReadWrite+fmShareDenyNone);
  filename3:='tmp\'+GrName+'_'+ListName+'_tstrout';
  tstrout:=TFileStream.Create(filename3,fmCreate);
  filename4:='tmp\'+GrName+'_'+ListName+'_tstroutmin';
  tstroutmin:=TFileStream.Create(filename4,fmCreate);
  filename5:='tmp\'+GrName+'_'+ListName+'_taddrout.txt';
  //taddrout:=TTextFileStream.Create(filename5,fmCreate);
  try
  filename:='tmp\'+GrName+'_'+ListName+'_addr.txt';
  addr.LoadFromFile(filename);
  filename0:='tmp\'+GrName+'_'+ListName+'_Origaddr.txt';
  Origaddr.LoadFromFile(filename0);
  tstrnew.position:=0;
  while tstrnew.position <>tstrnew.Size do begin
        tstrnew.read(lnw,2);
        SetLength(s, lnw);
        tstrnew.Read(s[1],lnw*sizeof(char));
        strnew.Append(s);
        end;
  tstrold.position:=0;
  while tstrold.position <>tstrold.Size do begin
        tstrold.read(lnw,2);
        SetLength(s, lnw);
        tstrold.Read(s[1],lnw*sizeof(char));
        strold.Append(s);
        end;
   if (addr.Count<>strnew.Count) or (strnew.Count<>strold.Count) or (addr.Count<>strold.Count) then exit;
    for i := 0 to Origaddr.Count-1 do
      for j := 0 to Origaddr.Count-1 do
        if length(strnew[i])>length(strnew[j]) then
          if (strtoint(Origaddr[j])-strtoint(Origaddr[i])=length(strold[i])-length(strold[j]))
          //or (strtoint(Origaddr[j])-strtoint(Origaddr[i])=length(strold[i])-length(strold[j])+1)
           then
          //if strtoint(addr[j])-strtoint(addr[i])=length(strold[i])-length(strold[j]) then
             begin
             stri:=strnew[i];
             strj:=strnew[j];
             kk:=0;
             for k:=1 to length(stri) do
                 //for k2:=1 to length(strj) do
                     if stri[k]=strj[1] then begin
                        strt:=Copy(stri,k,length(stri));
                        //if length(stri)-length(strt)+length(strj)=length(stri)-length(strj)
                        //then continue else
                        //if ((strt[length(strt)]=#0) or (strt[length(strt)-1]=#07)) and ((strj[length(strj)]=#0)or (strj[length(strj)-1]=#07)) then
                        if length(strt)= length(strj) then
                        for l:=1 to length(strt) do
                          if  strt[l]=strj[l] then inc(kk)
                          else begin kk:=0; break; end;
                          end;
             if kk=length(strj) then begin
               fList2.append(strnew[i]);
               fList3.append(strnew[j]);
               addrout.Append(addr[j]);
               kk:=0; end; end;
    //tstrout.position:=0;
    for i:=fList2.count-1 downto 0 do
     begin
        lnw:=length(fList2[i]);
        tstrout.Write(lnw,2);
        st:=fList2[i];
        tstrout.Write(st[1], lnw*sizeof(char));
     end;
   //tstroutmin.position:=0;
    for i:=fList3.count-1 downto 0 do
    begin
        lnw:=length(fList3[i]);
        tstroutmin.Write(lnw,2);
        st:=fList3[i];
        tstroutmin.Write(st[1], lnw*sizeof(char));
     end;
  finally
    addrout.SaveToFile(filename5);
    addrout.Free;
    addr.Free;
    Origaddr.Free;
    strnew.Free;
    strold.Free;
    fList2.Free;
    fList3.free;
  DeleteFile(filename);
  DeleteFile(filename0);
    tstrout.Free;
    tstroutmin.Free;
    tstrnew.Free;
    tstrold.Free;
  DeleteFile(filename1);
  DeleteFile(filename2);
  end;
end;

Procedure PlagTempClean(GrName,ListName:string); stdcall;
var
  filename:string;
begin
  filename:='tmp\'+GrName+'_'+ListName+'_taddrout.txt';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_tstrout';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_tstroutmin';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_taddroutGD';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_tstroutGD';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_NF';
  DeleteFile(filename);
  filename:='tmp\'+GrName+'_'+ListName+'_NFaddr';
  DeleteFile(filename);
  RemoveDir('tmp\');
end;

function GetStrings(X, Sz: Integer): PTextStrings; stdcall;
var
 P: PByte; PC: PChar absolute P;
 Code: Byte;
begin
 New(Result, Init);
 with Result.Add^ do
 begin
 Code := 0;
  P := Addr(ROM[X]);
  while P^ <> 0 do
  begin
   if ((P^ > $01) and (P^ < $0B))
   or ((P^ > $0B) and (P^ < $10))
then begin
    Code := P^;
    Str := Str + PC^;
    Inc(P);
    Str := Str + PC^;
   if Code = $07 then break;
    Inc(P)
end else
   begin
    Str := Str + PC^;
    Inc(P)
   end
  end ;
  if Code <> $07 then Str := Str + PC^
 end

end;

exports
 GetMethod,
 SetVariables,
 GetData,
 GetOptimization,
 Optimization,
 PlagPtrFix,
 PlagTempClean,
 GetStrings,
 DisposeStrings,
 NeedEnd,
 Description;

end.

