library NULL;

uses
  ShareMem,
  Needs,
  { 2      }
  Classes,
  SysUtils;
  //Needs in '..\..\Needs.pas';

{$E .kpl}

resourcestring
 SKPLDescription = 'NULL';

Var
 ROM: PBytes = NIL;
 RomSize: Integer = 0;
 EndsRoot: PTableItem = NIL;
 MaxCodes: Integer = 0;
 Align: Integer = 1;

Function Description: String; stdcall;
begin
 Result := SKPLDescription;
end;

Function NeedEnd: Boolean; stdcall;
begin
 Result := True;
end;

Function GetMethod: TMethod; stdcall;
begin
 Result := tmNone;
end;

Procedure SetVariables(X: PBytes; Sz: Integer; ER: PTableItem; MC, AL: Integer); stdcall;
begin
 ROM := X;
 RomSize := Sz;
 EndsRoot := ER;
 MaxCodes := MC;
 Align := AL;
end;

function GetData(Strings:Pointer; Table:Pointer; Flags,Address:integer; GrName,ListName:string; var plFixed:boolean; var SlStr:string): AnsiString; stdcall;
{ GetData.
 !  Pointer     ,
   ,          
 Strings -         
 Table -  ,   
 Flags -   
 Address -    
 GrName -    
 ListName -  
 plFixed -    ,      
 SlStr -      ,    . .  }
Var R: PTextString;
TextStrings:PtextStrings; //    GetData 
begin
 Result := '';
 TextStrings:=StringsToTextStrings(Table,Strings,Flags);    //       . Needs.pas
 If TextStrings = NIL then Exit;
 With TextStrings^ do
 begin
  R := Root;
  While R <> NIL do
  begin
   Result := Result + R^.Str + #0;
   R := R^.Next;
  end;
 end;
end;

Function GetStrings(X, Sz: Integer): PTextStrings; stdcall;
Var P: PChar;
begin
 Result := NIL;
 If (X >= RomSize) or (X < 0) then Exit;
 New(Result, Init);
 With Result^.Add^ do
 begin
  P := Addr(ROM^[X]);
  Str := P;
 end;
end;

Function GetOptimization(Strings:Pointer; Table:Pointer; Address:Integer; OrigAddr:Integer; Flags:integer; GrName:string; FirstStart:boolean):boolean; stdcall;
 { GetOptimization , ,    
         .     .
!  Pointer     ,
   ,          
    ,   ,     GetData,   
  Strings -         
  Table -  ,   
  Address -    
  OrigAddr -     ,      
     OSA.ptr,       ( ),
            
         ,   (    ),
      OSA        
  Flags -   
  GrName -    
  ListName -  
  FirstStart -  ,       True,
        ,      ,
       True,   FirstStart=False  ,
              False}
 begin
 Result:=true;
 end;

procedure Optimization(GrName,ListName:string); stdcall;
{      GetOptimization (  !)
        ,
    - Zelda - oracle of...
     SeekSame  }
 begin
 end;

procedure PlagPtrFix(PRoot:pointer; FlagStr,plStr:string;  GrName,ListName:string; PPointerTableData:TPointerTable;  var ROM:PBytes; var PP:PPointer; var Ptrs:PDwords; var BCounts:PDwords; Jk:integer; Var SkipWriteStrToROM:boolean); stdcall;
 begin end;
 { PlagPtrFix     ,   GetData,
       ..   begin end;
!  Pointer     ,
   ,          
  PRoot -   ,     ,   
  FlagStr -   GetData 
  plStr -  ,  FlagStr
  GrName -  
  ListName -  
  PPointerTableData -       ,   Needs.pas
  ROM -       
  PP -     ,    ,    . Needs.pas
  Ptrs -     ,   
  BCounts -    
  J -   
  SkipWriteStrToROM -    ,  ,  .  True -   ,   }

  //     
  //      GetData 
 {Function FindTextString(Node: PTextString; S: String): Integer;
    //  .    ,
      //       , ,
        //   
    begin
    Result := 0;
    While Node <> NIL do With Node^ do
      begin
        If S = Str then Exit;
        Inc(Result);
        Node := Next;
      end;
    Result := -1;
  end;
var
Root: PtextString absolute PRoot;
k:integer;
begin
//      
  with PPointerTableData do
    begin
        K:=FindTextString(Root, plStr);
        If (K>=0) and (Integer(Ptrs^[K])>= 0) then
        begin
         Ptrs^[J]:= Ptrs^[K];
         BCounts^[J]:= BCounts^[K];
         With PP^ do
         begin
          pnPtr:= Integer(Ptrs^[J]);
          If ptPunType then
           SetPointerPun(ROM, ptInterval, pnPos, pnPtr, pnReference) Else
           SetPointer(ROM, pnPos, pnPos, pnPtr, pnReference); //      Need.pas
         end;
       end;
    end;
end;}

Procedure PlagTempClean(GrName,ListName:string); stdcall;
{        
 GrName -  
 ListName -  }
begin
end;

exports
{     ,
        }
 GetMethod,
 SetVariables,
 GetData,
 GetOptimization,
 Optimization,
 PlagPtrFix,
 PlagTempClean,
 GetStrings,
 DisposeStrings,
 NeedEnd,
 Description;
end.

